/**
 * @file   Geometry.1d.cpp
 * @author Robert Lie
 * @date   Sun Apr 29 21:14:40 2007
 * 
 * @brief  
 * 
 * 
 */

#include "Geometry.templates.h"

#define DOW 1

	template class afepack::Point<DOW>;
	template class QuadratureInfo<DOW>;
	template class QuadratureInfoAdmin<DOW>;
	template class TemplateGeometry<DOW>;

	template afepack::Point<DOW> midpoint(const afepack::Point<DOW>&, const afepack::Point<DOW>&);
	template double distance(const afepack::Point<DOW>&, const afepack::Point<DOW>&);
	template afepack::Point<DOW> barycenter(const std::vector<afepack::Point<DOW> >&, const double *);
	template afepack::Point<DOW> operator+(const afepack::Point<DOW>&, const afepack::Point<DOW>&);
	template afepack::Point<DOW> operator-(const afepack::Point<DOW>&, const afepack::Point<DOW>&);

	template std::istream& operator>>(std::istream&, afepack::Point<DOW>&);
	template std::ostream& operator<<(std::ostream&, const afepack::Point<DOW>&);

	template filtering_istream& operator>>(filtering_istream&, QuadratureInfo<DOW>&);
	template std::ostream& operator<<(std::ostream&, const QuadratureInfo<DOW>&);

	template filtering_istream& operator>>(filtering_istream&, QuadratureInfoAdmin<DOW>&);
	template std::ostream& operator<<(std::ostream&, const QuadratureInfoAdmin<DOW>&);

	template filtering_istream& operator>>(filtering_istream&, TemplateGeometry<DOW>&);
	template std::ostream& operator<<(std::ostream&, const TemplateGeometry<DOW>&);

#define DIM 1
	template class Mesh<DIM,DOW>;
	template class SimplestMesh<DIM,DOW>;

	template std::istream& operator>>(std::istream&, Mesh<DIM,DOW>&);
	template std::ostream& operator<<(std::ostream&, const Mesh<DIM,DOW>&);
#undef DIM
	
#define DIM 2
	template class Mesh<DIM,DOW>;
	template class SimplestMesh<DIM,DOW>;

	template std::istream& operator>>(std::istream&, Mesh<DIM,DOW>&);
	template std::ostream& operator<<(std::ostream&, const Mesh<DIM,DOW>&);
#undef DIM
	
#define DIM 3
	template class Mesh<DIM,DOW>;
	template class SimplestMesh<DIM,DOW>;

	template std::istream& operator>>(std::istream&, Mesh<DIM,DOW>&);
	template std::ostream& operator<<(std::ostream&, const Mesh<DIM,DOW>&);
#undef DIM
#undef DOW

/**
 * end of file
 * 
 */
